Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions | Protected Attributes
Lucene::Document Class Reference

Documents are the unit of indexing and search. More...

`#include <Document.h>`

Inheritance diagram for Lucene::Document:

## Public Member Functions

| Document ()
| Constructs a new document with no fields. More...
virtual | ~Document ()
virtual String | getClassName ()
boost::shared_ptr< Document > | shared_from_this ()
void | setBoost (double boost)
| Sets a boost factor for hits on any field of this document. This value will be multiplied into the score of all hits on this document. More...
double | getBoost ()
| Returns, at indexing time, the boost factor as set by setBoost(double). More...
void | add (const FieldablePtr &field)
| Adds a field to a document. Several fields may be added with the same name. In this case, if the fields are indexed, their text is treated as though appended for the purposes of search. More...
void | removeField (const String &name)
| Removes field with the specified name from the document. If multiple fields exist with this name, this method removes the first field that has been added. If there is no field with the specified name, the document remains unchanged. More...
void | removeFields (const String &name)
| Removes all fields with the given name from the document. If there is no field with the specified name, the document remains unchanged. More...
FieldPtr | getField (const String &name)
| Returns a field with the given name if any exist in this document, or null. If multiple fields exists with this name, this method returns the first value added. Do not use this method with lazy loaded fields. More...
FieldablePtr | getFieldable (const String &name)
| Returns a field with the given name if any exist in this document, or null. If multiple fields exists with this name, this method returns the first value added. More...
String | get (const String &name)
| Returns the string value of the field with the given name if any exist in this document, or null. If multiple fields exist with this name, this method returns the first value added. If only binary fields with this name exist, returns null. More...
Collection< FieldablePtr > | getFields ()
| Returns a List of all the fields in a document. More...
Collection< FieldPtr > | getFields (const String &name)
| Returns an array of Fields with the given name. Do not use with lazy loaded fields. This method returns an empty array when there are no matching fields. It never returns null. More...
Collection< FieldablePtr > | getFieldables (const String &name)
| Returns an array of Fieldables with the given name. This method returns an empty array when there are no matching fields. It never returns null. More...
Collection< String > | getValues (const String &name)
| Returns an array of values of the field specified as the method parameter. This method returns an empty array when there are no matching fields. It never returns null. More...
Collection< ByteArray > | getBinaryValues (const String &name)
| Returns an array of byte arrays for of the fields that have the name specified as the method parameter. This method returns an empty array when there are no matching fields. It never returns null. More...
ByteArray | getBinaryValue (const String &name)
| Returns an array of bytes for the first (or only) field that has the name specified as the method parameter. This method will return null if no binary fields with the specified name are available. There may be non-binary fields with the same name. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()

## Protected Attributes

Collection< FieldablePtr > | fields
double | boost
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Detailed Description

Documents are the unit of indexing and search.

A Document is a set of fields. Each field has a name and a textual value. A field may be stored with the document, in which case it is returned with search hits on the document. Thus each document should typically contain one or more stored fields which uniquely identify it.

Note that fields which are not stored are not available in documents retrieved from the index, eg. with ScoreDoc#doc, Searcher#doc(int) or IndexReader#document(int).

## Constructor & Destructor Documentation

Lucene::Document::Document | ( |  | ) |

Constructs a new document with no fields.

virtual Lucene::Document::~Document | ( |  | ) |

virtual

## Member Function Documentation

static String Lucene::Document::_getClassName | ( |  | ) |

inline static

void Lucene::Document::add | ( | const FieldablePtr & | field | ) |

Adds a field to a document. Several fields may be added with the same name. In this case, if the fields are indexed, their text is treated as though appended for the purposes of search.

Note that add like the removeField(s) methods only makes sense prior to adding a document to an index. These methods cannot be used to change the content of an existing index! In order to achieve this, a document has to be deleted from an index and a new changed version of that document has to be added.

String Lucene::Document::get | ( | const String & | name | ) |

Returns the string value of the field with the given name if any exist in this document, or null. If multiple fields exist with this name, this method returns the first value added. If only binary fields with this name exist, returns null.

ByteArray Lucene::Document::getBinaryValue | ( | const String & | name | ) |

Returns an array of bytes for the first (or only) field that has the name specified as the method parameter. This method will return null if no binary fields with the specified name are available. There may be non-binary fields with the same name.

Parameters

  name | the name of the field.

Returns
  a byte[] containing the binary field value or null

Collection<ByteArray> Lucene::Document::getBinaryValues | ( | const String & | name | ) |

Returns an array of byte arrays for of the fields that have the name specified as the method parameter. This method returns an empty array when there are no matching fields. It never returns null.

Parameters

  name | the name of the field

Returns
  a byte[][] of binary field values

double Lucene::Document::getBoost | ( |  | ) |

Returns, at indexing time, the boost factor as set by setBoost(double).

Note that once a document is indexed this value is no longer available from the index. At search time, for retrieved documents, this method always returns 1. This however does not mean that the boost value set at indexing time was ignored - it was just combined with other indexing time factors and stored elsewhere, for better indexing and search performance. (For more information see the "norm(t,d)" part of the scoring formula in Similarity.)

See also
  setBoost(double)

virtual String Lucene::Document::getClassName | ( |  | ) |

inline virtual

FieldPtr Lucene::Document::getField | ( | const String & | name | ) |

Returns a field with the given name if any exist in this document, or null. If multiple fields exists with this name, this method returns the first value added. Do not use this method with lazy loaded fields.

FieldablePtr Lucene::Document::getFieldable | ( | const String & | name | ) |

Returns a field with the given name if any exist in this document, or null. If multiple fields exists with this name, this method returns the first value added.

Collection<FieldablePtr> Lucene::Document::getFieldables | ( | const String & | name | ) |

Returns an array of Fieldables with the given name. This method returns an empty array when there are no matching fields. It never returns null.

Parameters

  name | the name of the field

Returns
  a Fieldable[] array

Collection<FieldablePtr> Lucene::Document::getFields | ( |  | ) |

Returns a List of all the fields in a document.

Note that fields which are not stored are not available in documents retrieved from the index, eg. Searcher#doc(int) or IndexReader#document(int).

Collection<FieldPtr> Lucene::Document::getFields | ( | const String & | name | ) |

Returns an array of Fields with the given name. Do not use with lazy loaded fields. This method returns an empty array when there are no matching fields. It never returns null.

Parameters

  name | the name of the field

Returns
  a Field[] array

Collection<String> Lucene::Document::getValues | ( | const String & | name | ) |

Returns an array of values of the field specified as the method parameter. This method returns an empty array when there are no matching fields. It never returns null.

Parameters

  name | the name of the field

Returns
  a String[] of field values

void Lucene::Document::removeField | ( | const String & | name | ) |

Removes field with the specified name from the document. If multiple fields exist with this name, this method removes the first field that has been added. If there is no field with the specified name, the document remains unchanged.

Note that the removeField(s) methods like the add method only make sense prior to adding a document to an index. These methods cannot be used to change the content of an existing index! In order to achieve this, a document has to be deleted from an index and a new changed version of that document has to be added.

void Lucene::Document::removeFields | ( | const String & | name | ) |

Removes all fields with the given name from the document. If there is no field with the specified name, the document remains unchanged.

Note that the removeField(s) methods like the add method only make sense prior to adding a document to an index. These methods cannot be used to change the content of an existing index! In order to achieve this, a document has to be deleted from an index and a new changed version of that document has to be added.

void Lucene::Document::setBoost | ( | double | boost | ) |

Sets a boost factor for hits on any field of this document. This value will be multiplied into the score of all hits on this document.

The default value is 1.0.

Values are multiplied into the value of Fieldable#getBoost() of each field in this document. Thus, this method in effect sets a default boost for the fields of this document.

See also
  Fieldable::setBoost(double)

boost::shared_ptr< Document > Lucene::Document::shared_from_this | ( |  | ) |

inline

virtual String Lucene::Document::toString | ( |  | ) |

virtual

Returns a string representation of the object.

Reimplemented from Lucene::LuceneObject.

## Field Documentation

double Lucene::Document::boost

protected

Collection<FieldablePtr> Lucene::Document::fields

protected

The documentation for this class was generated from the following file:

- Document.h

clucene.sourceforge.net